Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/entity/Result.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/entity/Result.java	(nonexistent)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/entity/Result.java	(revision 41791)
@@ -0,0 +1,212 @@
+package eu.dnetlib.data.claims.migration.entity;
+
+import eu.dnetlib.data.claimsDemo.ClaimUtils;
+
+/**
+ * Created by kiatrop on 20/11/2015.
+ */
+public class Result implements  OpenaireEntity{
+    private String title;
+//external url: url+doi (if doi exists) or url from websources
+    private String externalUrl;
+    private String openaireId;
+    private String doi;
+    private String orcidworkid;
+    private String pmcid;
+    //accessRights : set by user
+    private String accessRights;
+    //bestLicence : from search
+    private String bestLicense;
+
+    private String collectedFrom;
+    private String metadataRecord;
+
+//for the metadataRecord file
+    private String recordPath;
+    private String recordFormat;
+
+    private String resultType;
+//    private boolean found=false;
+    private String embargoEndDate;
+
+//Used for Datacite
+    private String oai;
+    private String provenanceaction;
+
+
+    public String getDoi() {
+		return doi;
+	}
+
+	public void setDoi(String doi) {
+		this.doi = doi;
+	}
+
+	public String getTitle() {
+        return title;
+    }
+
+    public void setTitle(String title) {
+        this.title = title;
+    }
+
+    public String getExternalUrl() {
+        return externalUrl;
+    }
+
+    public void setExternalUrl(String externalUrl) {
+        this.externalUrl = externalUrl;
+    }
+
+    public String getOpenaireId() {
+        return openaireId;
+    }
+
+    public void setOpenaireId(String openaire_id) {
+        this.openaireId = openaire_id;
+    }
+
+    public String getAccessRights() {
+        return accessRights;
+    }
+
+    public void setAccessRights(String accessRights) {
+        this.accessRights = accessRights;
+    }
+
+    public String getBestLicense() {
+        return bestLicense;
+    }
+
+    public void setBestLicense(String bestLicense) {
+        this.bestLicense = bestLicense;
+    }
+
+    public String getCollectedFrom() {
+        return collectedFrom;
+    }
+
+    public void setCollectedFrom(String collectedFrom) {
+        if(!collectedFrom.contains("____::")) {
+            if (collectedFrom.equals("Datacite")) {
+                collectedFrom = ClaimUtils.COLLECTED_FROM_DATACITE;
+
+            } else if (collectedFrom.equals("Crossref")) {
+                collectedFrom = ClaimUtils.COLLECTED_FROM_CROSSREF;
+
+            } else if (collectedFrom.equals("Orcid")) {
+                collectedFrom = ClaimUtils.COLLECTED_FROM_ORCID;
+
+            } else {
+                collectedFrom = ClaimUtils.COLLECTED_FROM_OPENAIRE;
+            }
+        }
+        this.collectedFrom = collectedFrom;
+    }
+
+    public String getMetadataRecord() {
+        return metadataRecord;
+    }
+
+    public void setMetadataRecord(String metadataRecord) {
+        this.metadataRecord = metadataRecord;
+    }
+
+    public String getResultType() {
+        return resultType;
+    }
+
+    public void setResultType(String resultType) {
+        this.resultType = resultType;
+    }
+
+
+
+/*    public boolean isFound() {
+        return found;
+    }
+
+    public void setFound(boolean found) {
+        this.found = found;
+    }*/
+
+    public String getPmcid() {
+        return pmcid;
+    }
+
+    public void setPmcid(String pmcid) {
+        this.pmcid = pmcid;
+    }
+
+    public String getOrcidworkid() {
+        return orcidworkid;
+    }
+
+    public void setOrcidworkid(String orcidworkid) {
+        this.orcidworkid = orcidworkid;
+    }
+
+    public String getEmbargoEndDate() {
+        return embargoEndDate;
+    }
+
+    public void setEmbargoEndDate(String embargoEndDate) {
+        this.embargoEndDate = embargoEndDate;
+    }
+
+    public String getOai() {
+        return oai;
+    }
+
+    public void setOai(String oai) {
+        this.oai = oai;
+    }
+
+    public String getProvenanceaction() {
+        return provenanceaction;
+    }
+
+    public void setProvenanceaction(String provenanceaction) {
+        this.provenanceaction = provenanceaction;
+    }
+
+    public String getRecordPath() {
+        return recordPath;
+    }
+
+    public void setRecordPath(String recordPath) {
+        this.recordPath = recordPath;
+    }
+
+    public String getRecordFormat() {
+        return recordFormat;
+    }
+
+    public void setRecordFormat(String recordFormat) {
+        this.recordFormat = recordFormat;
+    }
+
+    @Override
+    public String toString() {
+        return "\nResult{" +
+                "title='" + title + '\'' +
+                ",\n external_url='" + externalUrl + '\'' +
+                ",\n openaire_id='" + openaireId + '\'' +
+                ",\n doi='" + doi + '\'' +
+                ",\n pmcid='" + pmcid + '\'' +
+                ",\n orcidworkid='" + orcidworkid + '\'' +
+                ",\n accessRights='" + accessRights + '\'' +
+                ",\n embargoEndDate='" + embargoEndDate + '\'' +
+                ",\n bestLicense='" + bestLicense + '\'' +
+                ",\n collectedFrom='" + collectedFrom + '\'' +
+                ",\n oai='" + oai + '\'' +
+                ",\n provenanceaction='" + provenanceaction + '\'' +
+                ",\n metadataRecord='" + ((metadataRecord!=null)?metadataRecord.substring(0,60):null) + "...\'" +
+                ",\n recordPath='" + recordPath + '\'' +
+                ",\n recordFormat='" + recordFormat + '\'' +
+                ",\n resultType='" + resultType + '\'' +
+                '}';
+    }
+//method to ask from API of search to get the metadataRecord
+    //then parse the fields
+}
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/OafParser.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/OafParser.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/OafParser.java	(revision 41791)
@@ -1,7 +1,7 @@
 package eu.dnetlib.data.claims.migration.parser;
 
-import eu.dnetlib.data.claims.migration.Project;
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Project;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claimsDemo.ClaimUtils;
 import org.w3c.dom.Document;
 import org.w3c.dom.NodeList;
@@ -12,7 +12,6 @@
 import javax.xml.parsers.DocumentBuilderFactory;
 import javax.xml.parsers.ParserConfigurationException;
 import javax.xml.transform.Transformer;
-import javax.xml.transform.TransformerConfigurationException;
 import javax.xml.transform.TransformerException;
 import javax.xml.transform.TransformerFactory;
 import javax.xml.transform.dom.DOMSource;
@@ -144,7 +143,7 @@
              result.setMetadataRecord(writer.toString());
             result.setCollectedFrom(ClaimUtils.COLLECTED_FROM_OPENAIRE);
             result.setRecordFormat(ClaimUtils.FORMAT_XML);
-            result.setFound(true);
+//            result.setFound(true);
 
         }
 
@@ -194,7 +193,7 @@
                 project.setFunderId(nl.item(0).getNodeValue());
             }
 
-            project.setFound(true);
+//            project.setFound(true);
 
         }
 
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/DMFParser.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/DMFParser.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/DMFParser.java	(revision 41791)
@@ -1,7 +1,7 @@
 package eu.dnetlib.data.claims.migration.parser;
 
-import eu.dnetlib.data.claims.migration.Context;
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Context;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claimsDemo.ClaimUtils;
 import eu.dnetlib.data.claimsDemo.ContextUtils;
 import org.w3c.dom.Document;
@@ -89,39 +89,7 @@
         return r;
     }
 
-    static public Context dmf2Context(String xml) {
-        Context context = new Context();
-        try {
-            DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
-            DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
-            InputSource inputSource = new InputSource(new StringReader(xml));
-            Document document = dBuilder.parse(inputSource);
-            XPathFactory xPathfactory = XPathFactory.newInstance();
-            XPath xpath = xPathfactory.newXPath();
-            NodeList nl = (NodeList) xpath.compile("//*[local-name()='concept']/@id").evaluate(document, XPathConstants.NODESET);
-            if (nl.getLength() > 0) {
-                context.setOpenaireId(nl.item(0).getNodeValue());
-            }
-        } catch (Exception e) {
-            e.printStackTrace();
-        }
-        buildContext(context);
-        return context;
 
-    }
-
-    static private void buildContext(Context context) {
-        if (context != null && context.getOpenaireId() != null) {
-            try {
-                context.setTitle(ContextUtils.extractEgiLabel(context.getOpenaireId()));
-
-            } catch (Exception e) {
-                e.printStackTrace();
-                System.err.println("ContextUtils: Couldn't get Egi label for id " + context.getOpenaireId());
-            }
-        }
-    }
-
     /**
      *
      * @param xml of a context DMF
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/RelationParser.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/RelationParser.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/RelationParser.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.parser;
 
-import eu.dnetlib.data.claims.migration.Relation;
+import eu.dnetlib.data.claims.migration.entity.Relation;
 import eu.dnetlib.data.claimsDemo.ClaimUtils;
 import org.apache.log4j.Logger;
 import org.w3c.dom.Document;
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/ExternalRecordParser.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/ExternalRecordParser.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/parser/ExternalRecordParser.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.parser;
 
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claimsDemo.ClaimUtils;
 import org.w3c.dom.Document;
 import org.w3c.dom.NodeList;
@@ -50,7 +50,7 @@
             result= new Result();
             result.setMetadataRecord(json);
             result.setRecordFormat(ClaimUtils.FORMAT_JSON);
-            result.setFound(true);
+//            result.setFound(true);
             result.setCollectedFrom(ClaimUtils.COLLECTED_FROM_CROSSREF);
             Response.Message.Item item= obj.getMessage().getItems().get(0);
             if(item.getTitle()!=null && item.getTitle().size()>0){
@@ -145,7 +145,7 @@
                 result.setMetadataRecord(writer.toString());
                 result.setRecordFormat(ClaimUtils.FORMAT_XML);
                 result.setCollectedFrom(ClaimUtils.COLLECTED_FROM_ORCID);
-                result.setFound(true);
+//                result.setFound(true);
             }
 
         } catch (Exception e) {
@@ -191,7 +191,7 @@
                 result.setMetadataRecord(xml);
                 result.setRecordFormat(ClaimUtils.FORMAT_XML);
                 result.setCollectedFrom(ClaimUtils.COLLECTED_FROM_DATACITE);
-                result.setFound(true);
+//                result.setFound(true);
             }
         } catch (Exception e) {
             e.printStackTrace();
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ExternalRecordHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ExternalRecordHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ExternalRecordHandler.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claims.migration.parser.ExternalRecordParser;
 import eu.dnetlib.data.claimsDemo.SearchUtils;
 
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ContextRelationHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ContextRelationHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ContextRelationHandler.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.ContextRelation;
+import eu.dnetlib.data.claims.migration.entity.ContextRelation;
 import eu.dnetlib.data.claims.migration.parser.DMFParser;
 import eu.dnetlib.data.claimsDemo.QueryGenerator;
 import eu.dnetlib.data.claimsDemo.SqlDAO;
@@ -21,7 +21,7 @@
     public List<ContextRelation> fetchAllConceptRelations() throws Exception {
         List<ContextRelation> relations = null;
 //          ResultSet rs = sqlDAO.executePreparedQuery(queryGenerator.generateQueryForTesting(-1,"169112"));
-        ResultSet rs = sqlDAO.executePreparedQuery(queryGenerator.generateSelectConceptClaimsEnrichedWithDMFClaimsQuery(-1));
+        ResultSet rs = sqlDAO.executePreparedQuery(queryGenerator.generateSelectConceptClaimsEnrichedWithDMFClaimsQuery(2));
         relations = new ArrayList<ContextRelation>();
 
         while(rs.next()) {
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ClaimHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ClaimHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ClaimHandler.java	(revision 41791)
@@ -1,13 +1,13 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.Claim;
-import eu.dnetlib.data.claims.migration.Context;
-import eu.dnetlib.data.claims.migration.Project;
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.ClaimValidation;
+import eu.dnetlib.data.claims.migration.entity.*;
+import eu.dnetlib.data.claims.migration.parser.DMFParser;
 import eu.dnetlib.data.claimsDemo.ClaimUtils;
 import eu.dnetlib.data.claimsDemo.QueryGenerator;
 import eu.dnetlib.data.claimsDemo.SqlDAO;
 
+import java.util.Date;
 import java.util.List;
 
 /**
@@ -21,6 +21,10 @@
     DMFContextHandler dmfContextHandler = null;
     ProjectHandler projectHandler = null;
 
+    /**
+     * Saves a list of claims in DB
+     * @param claims
+     */
     public void saveClaims(List<Claim> claims){
         for(Claim claim:claims){
             try {
@@ -34,20 +38,136 @@
    public String  generateSaveQueryForClaim(Claim claim){
 
        String query= null;
-       if (claim.getSourceType().equals(ClaimUtils.CONTEXT)) {
+       /*if (claim.getSourceType().equals(ClaimUtils.CONTEXT)) {
            query = queryGenerator.generateInsertClaimContextQuery(resultHandler.generateSaveQueryForResult(((Result)claim.getTarget())),dmfContextHandler.generateSaveQueryForContext ((Context) claim.getSource()), claim);
        } else if (claim.getSourceType().equals(ClaimUtils.PROJECT)) {
            query = queryGenerator.generateInsertClaimProjectQuery(resultHandler.generateSaveQueryForResult((Result)claim.getTarget()), projectHandler.generateSaveQueryForProject((Project) claim.getSource()), claim);
        } else{
            query = queryGenerator.generateInsertClaimResultQuery(resultHandler.generateSaveQueryForResult((Result)claim.getTarget()), resultHandler.generateSaveQueryForResult((Result) claim.getSource()), claim);
-       }
+       }*/
+       query = queryGenerator.generateInsertFullClaimQuery(claim);
        return query;
    }
-
+    /**
+     * saves a claim in DB
+     * @param claim
+     * @throws Exception
+     */
     public void saveClaim(Claim claim) throws Exception {
         sqlDAO.executeUpdateQuery(generateSaveQueryForClaim(claim));
     }
 
+    /**
+     * Gets the main information for a claim relation - builds a claim object
+     * exports metadata
+     * and saves the claim relations in the DB
+     * @param user
+     * @param date
+     * @param sourceType
+     * @param sourceId
+     * @param sourceCollectedFrom
+     * @param targetType
+     * @param targetId
+     * @param targetCollectedFrom
+     * @throws Exception
+     */
+    public void buildAndInsertClaim(String user, Date date, String sourceType, String sourceId, String sourceCollectedFrom, String targetType, String targetId, String targetCollectedFrom) throws Exception {
+        Claim claim = buildClaim(user,date,sourceType,sourceId,sourceCollectedFrom, targetType, targetId, targetCollectedFrom);
+        ClaimValidation claimValidation = new ClaimValidation();
+        System.out.print(claim.toString());
+        if(claimValidation.validateClaim(claim)) {
+            claim = exportMedatataForClaim(claim);
+            saveClaim(claim);
+        }
+    }
+
+    /**
+     * Gets the main information of a relation claim and
+     * builds a claim object
+     * @param user
+     * @param date
+     * @param sourceType publication, dataset, project, context
+     * @param sourceId openaireId, doi or orcid workid
+     * @param sourceCollectedFrom only for source with type publication, dataset
+     * @param targetType publication, dataset, project, context
+     * @param targetId openaireId, doi or orcid workid
+     * @param targetCollectedFrom only for target with type publication, dataset
+     * @return a claim object
+     * @throws Exception
+     */
+    private Claim buildClaim(String user,Date date, String sourceType,String sourceId,String sourceCollectedFrom,  String targetType,String targetId,String targetCollectedFrom ) throws Exception {
+        Claim claim = new Claim();
+        claim.setUserMail(user);
+        claim.setDate(date);
+        //date
+        claim.setSourceType(sourceType);
+        claim.setTargetType(targetType);
+        claim.setSource(buildOpenaireEntity(sourceId,sourceType,sourceCollectedFrom));
+        claim.setTarget(buildOpenaireEntity(targetId,targetType,targetCollectedFrom));
+        //TODO from external sources need an OPenaireID
+
+        return claim;
+
+    }
+
+    /**
+     * Gets the main information of an openaire entity
+     * and returns a full  object
+     * @param id
+     * @param type
+     * @param collectedFrom
+     * @return openaire Entity (Context, Result, Project)
+     * @throws Exception
+     */
+    private OpenaireEntity buildOpenaireEntity(String id, String type, String collectedFrom) throws Exception {
+        if(type==null){
+            return null;
+        }
+        else if(type.equals(ClaimUtils.CONTEXT)){
+            return DMFContextHandler.fetchContextById(id);
+        }else if (type.equals(ClaimUtils.PROJECT)){
+            return projectHandler.fetchProjectByID(id);
+        }else if (type.equals(ClaimUtils.PUBLICATION)||type.equals(ClaimUtils.DATASET)){
+            ExternalRecordHandler externalRecordHandler = new ExternalRecordHandler();
+            if(collectedFrom == null){
+                return null;
+            }else if(collectedFrom.equals(ClaimUtils.CROSSREF)){
+                return externalRecordHandler.fetchResultfromCrossref(id);
+            }else if (collectedFrom.equals(ClaimUtils.DATACITE)){
+                return externalRecordHandler.fetchResultfromDatacite(id);
+            }else if (collectedFrom.equals(ClaimUtils.ORCID)){
+                return externalRecordHandler.fetchResultfromOrcid(id);
+            }else if (collectedFrom.equals(ClaimUtils.OPENAIRE)){
+                IndexResultHandler indexResultHandler = new IndexResultHandler();
+                return indexResultHandler.fetchResultById(id);
+            }
+        }
+        return null;
+    }
+
+
+    /**
+     * Exports the metadata for the source and the target of a claim and sets the proper field
+     * @param claim
+     * @return claim with the proper metadata path of the result of source and target
+     */
+    public Claim exportMedatataForClaim(Claim claim){
+        if(claim.getTargetType().equals(ClaimUtils.DATASET)||claim.getTargetType().equals(ClaimUtils.PUBLICATION)){
+            String path = resultHandler.exportMetadataFileForResult((Result)claim.getTarget());
+            ((Result) claim.getTarget()).setRecordPath(path);
+        }
+        if(claim.getSourceType().equals(ClaimUtils.DATASET)||claim.getSourceType().equals(ClaimUtils.PUBLICATION)){
+            String path = resultHandler.exportMetadataFileForResult((Result)claim.getSource());
+            ((Result) claim.getSource()).setRecordPath(path);
+        }
+        return claim;
+
+    }
+
+    public void deleteClaim(String user, String claimId){
+        //TODO
+    }
+
     public SqlDAO getSqlDAO() {
         return sqlDAO;
     }
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/DMFResultHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/DMFResultHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/DMFResultHandler.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claims.migration.parser.DMFParser;
 import eu.dnetlib.data.claimsDemo.*;
 import org.xml.sax.SAXException;
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/IndexResultHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/IndexResultHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/IndexResultHandler.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claims.migration.parser.OafParser;
 import eu.dnetlib.data.claimsDemo.SearchUtils;
 
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/DMFContextHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/DMFContextHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/DMFContextHandler.java	(revision 41791)
@@ -1,10 +1,15 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.Context;
+import eu.dnetlib.data.claims.migration.entity.Context;
 import eu.dnetlib.data.claims.migration.parser.DMFParser;
+import eu.dnetlib.data.claimsDemo.ContextUtils;
 import eu.dnetlib.data.claimsDemo.QueryGenerator;
 import eu.dnetlib.data.claimsDemo.SqlDAO;
+import org.xml.sax.SAXException;
 
+import javax.xml.parsers.ParserConfigurationException;
+import javax.xml.xpath.XPathExpressionException;
+import java.io.IOException;
 import java.sql.ResultSet;
 
 /**
@@ -25,16 +30,32 @@
         return rs.getString("xml");
     }
 
-    public Context fetchContextByDMF(String xml)  {
-        return dmfParser.dmf2Context(xml);
+    public Context fetchContextByDMF(String xml) throws ParserConfigurationException, SAXException, XPathExpressionException, IOException {
+        return fetchContextById(dmfParser.getContextIdFromDMF(xml));
     }
 
-    public Context fetchContextById(String id) throws Exception {
+    public Context fetchContextByIdFromDmf(String id) throws Exception {
         return fetchContextByDMF(fetchDMFContext(id));
     }
 
-    public String generateSaveQueryForContext(Context context){
+    static public Context fetchContextById(String openaireId) {
+        Context context = new Context();
+        if(openaireId == null ){
+            return null;
+        }
+        context.setOpenaireId(openaireId);
+        try {
+            context.setTitle(ContextUtils.extractEgiLabel(context.getOpenaireId()));
 
+        } catch (Exception e) {
+            e.printStackTrace();
+            System.err.println("ContextUtils: Couldn't get Egi label for id " + context.getOpenaireId());
+        }
+        return context;
+
+    }
+/*    public String generateSaveQueryForContext(Context context){
+
         return queryGenerator.generateInsertContextQuery(context.getOpenaireId(),context.getTitle());
     }
 
@@ -41,7 +62,7 @@
     public void saveContext(Context context) throws Exception {
 
         sqlDAO.executePreparedQuery(generateSaveQueryForContext(context));
-    }
+    }*/
 
     public SqlDAO getSqlDAO() {
         return sqlDAO;
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ResultHandler.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ResultHandler.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claims/migration/handler/ResultHandler.java	(revision 41791)
@@ -1,6 +1,6 @@
 package eu.dnetlib.data.claims.migration.handler;
 
-import eu.dnetlib.data.claims.migration.Result;
+import eu.dnetlib.data.claims.migration.entity.Result;
 import eu.dnetlib.data.claimsDemo.ClaimUtils;
 import eu.dnetlib.data.claimsDemo.QueryGenerator;
 import eu.dnetlib.data.claimsDemo.SqlDAO;
@@ -16,12 +16,12 @@
     SqlDAO sqlDAO = null;
     QueryGenerator queryGenerator = null;
 
-    public String generateSaveQueryForResult(Result result){
+/*    public String generateSaveQueryForResult(Result result){
         return queryGenerator.generateInsertResultQuery(result.getOpenaireId(),result.getResultType(),result.getTitle(),result.getCollectedFrom(),result.getExternalUrl(),result.getDoi(), result.getOrcidworkid(), result.getAccessRights(),result.getEmbargoEndDate(),result.getBestLicense(),result.getRecordPath(), result.getRecordFormat());
     }
     public void saveResult(Result result) throws Exception {
         sqlDAO.executePreparedQuery(generateSaveQueryForResult(result));
-    }
+    }*/
 
     public String exportMetadataFileForResult(Result result)  {
         if(result.getOpenaireId()!=null && result.getMetadataRecord()!=null){
Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claimsDemo/SqlDAO.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claimsDemo/SqlDAO.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claimsDemo/SqlDAO.java	(revision 41791)
@@ -100,6 +100,7 @@
 
 		{
 			log.error(e.getMessage());
+            log.error("Query is : "+q);
 			throw new Exception(e);
 		}
 
